--| 02/10/2012
--| 
--| ENUNCIADO:
--| Escribe un procedimiento en Ada que lance 3 tareas, la primera de ellas
--| que escriba 10 veces "Soy T1", la segunda 15 veces "Soy T2" y la tercera
--| 4 veces "Soy T3". El procedimiento escribir 7 veces "Soy P". Ejecutar
--| dicho procedimiento varias veces observando su comportamiento.

--| CONCLUSION:
--| El programa al ejecutarlo realiza las tres taras y su propio codigo
--| al mismo tiempo. Como todas ellas imprimen por pantalla se puede
--| observar que cada proceso (o el propio procedimiento) imprimen cuando
--| consiguen tiempo de proceso, eso quiere decir que en algunas ejecuciones
--| consiguen hacer todo el codigo de la tarea de golpe, pero en la mayoria
--| de las veces eso no es asi, cortandose la tarea para que entre otra de
--| ellas y ejecute su codigo. Por lo tanto la salida por pantalla, y por
--| tanto la forma de ejecutarse el programa, nunca, o casi nunca, es igual.

--| EJECUCION:
--| Soy    T1
--| Soy    T1
--| Soy    T1
--| Soy          T3
--| Soy          T3
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy P
--| Soy P
--| Soy P
--| Soy P
--| Soy P
--| Soy P
--| Soy P
--| Soy          T3
--| Soy          T3
--| Soy    T1
--| Soy    T1
--| Soy    T1
--| Soy    T1
--| Soy    T1
--| Soy    T1
--| Soy    T1

--| NOTAS:
--| http://es.scribd.com/doc/91573599/63/CONCURRENCIA-EN-ADA


with Ada.Text_IO;


--| Procedimiento principal:
procedure ada1x01 is
	
	use Ada.Text_IO;

	--| Especificacion de las tareas:
	task t1;
	task t2;
	task t3;

	
	--| Implementacion de las tareas:	
	task body t1 is
	begin
		for c in 1..10 loop
			put_line("Soy    T1");
		end loop;	
	end t1;
	
	
	task body t2 is
	begin
		for c in 1..15 loop
			put_line("Soy       T2");
		end loop;
	end t2;
	
	
	task body t3 is
	begin
		for c in 1..4 loop
			put_line("Soy          T3");
		end loop;	
	end t3;

begin

	--| Las tareas se ejecutan al mismo tiempo junto al codigo del procedimiento.
	
	for c in 1..7 loop
		put_line("Soy P");
	end loop;
		
end ada1x01;
