--| 03/10/2012
--| 
--| ENUNCIADO:
--| Con el objetivo de que una tarea no monopolice el microprocesador
--| hasta terminar, vamos a aadir una instruccin delay tras el mensaje
--| que escribe cada una de ellas y tras el que escribe el procedimiento.
--| Ejecutar el procedimiento varias veces, cambiar el tiempo asociado a
--| cada delay, probar mismos tiempos y distintos, y observar su comportamiento.

--| CONCLUSION:
--| Al realizar pausas despues de cada impresion de cada tarea/procedimiento,
--| conseguimos que durante esa pausa la tarea/procedimiento pierda su tiempo
--| de ejecucion y se ponga a trabajar otra, esto hace que cada tarea/procedimiento
--| este menos tiempo seguido en ejecucion y el resultado de ejecucion sea mas "mezclado"

--| EJECUCION:
--| Soy       T2
--| Soy    T1
--| Soy          T3
--| Soy P
--| Soy       T2
--| Soy P
--| Soy          T3
--| Soy    T1
--| Soy          T3
--| Soy       T2
--| Soy    T1
--| Soy P
--| Soy       T2
--| Soy P
--| Soy          T3
--| Soy    T1
--| Soy       T2
--| Soy    T1
--| Soy P
--| Soy    T1
--| Soy       T2
--| Soy P
--| Soy    T1
--| Soy P
--| Soy       T2
--| Soy       T2
--| Soy    T1
--| Soy    T1
--| Soy       T2
--| Soy       T2
--| Soy    T1
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2
--| Soy       T2


with Ada.Text_IO;


--| Procedimiento principal:
procedure ada1x02 is
	
	use Ada.Text_IO;

	--| Especificacion de las tareas:
	task t1;
	task t2;
	task t3;

	
	--| Implementacion de las tareas:	
	task body t1 is
	begin
		for c in 1..10 loop
			put_line("Soy    T1");
			delay 0.01;
		end loop;
	end t1;
	
	
	task body t2 is
	begin
		for c in 1..15 loop
			put_line("Soy       T2");
			delay 0.01; -- Se pausa (deja de ejecutarse) el proceso 10 milisegundos, entonces entrara a ejecucion otro proceso.
		end loop;
	end t2;
	
	
	task body t3 is
	begin
		for c in 1..4 loop
			put_line("Soy          T3");
			delay 0.01;
		end loop;	
	end t3;

begin

	for c in 1..7 loop
		put_line("Soy P");
		delay 0.01;
	end loop;
		
end ada1x02;
