--| 03/10/2012
--| 
--| ENUNCIADO:
--| En lugar de definir 3 tareas de 3 tipos diferentes, definir una tarea
--| tipo que admita tres parmetros (carcter a escribir en los mensajes,
--| tiempo de parada de la tarea tras mostrar mensaje y nmero de veces
--| que queremos que salga el mensaje con su correspondiente parada entre 
--| ellos-). El mensaje que saldr ser Soy x, siendo x el carcter pasado
--| como primer parmetro.

--| RESUMEN:
--| En vez de especificar e implementar tres tareas, se crea una sola como un
--| tipo tarea, se instancian tres variables de ese tipo tarea pasandole los
--| parametros y listo.

--| CONCLUSION:
--| Ahora el programa con tres tareas (creadas a partir de un tipo Tarea)
--| y el codigo del procedimiento realizan lo mismo que en el ejercicio
--| anterior, sin embargo hay una gran diferencia a la hora de que cada
--| tarea/procedimiento imprima su codigo, y es que al tener que imprimir:
--| "Soy t" + numero + salto de linea, ocurre que otra tarea pueda interferir
--| justo en medio de la impresion y por lo tanto se muestre incorrectamente.
--| Quizas se solucionaria si se concatenaran las tres partes y se imprimieran
--| con una sola operacion...

--| EJECUCION:
--| Soy tSoy P
--| Soy t1
--| 2
--| Soy t3
--| Soy P
--| Soy P
--| Soy P
--| Soy P
--| Soy P
--| Soy P
--| Soy t1
--| Soy tSoy t1
--| 3
--| Soy t1
--| Soy t2
--| Soy t3
--| Soy t1
--| Soy t1
--| Soy t3
--| Soy t1
--| Soy t1
--| Soy t2
--| Soy t1
--| Soy t1
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2
--| Soy t2


with Ada.Text_IO;


--| Procedimiento principal:
procedure ada1x03 is
	
	use Ada.Text_IO;
	
	--| Especificacion de la tarea:
	task type tarea(caracter:Character ; repeticiones:Integer ; tiempo:Integer);
	
	
	--| Implementacion de la tarea:
	task body tarea is
		temp:Float := float(tiempo);
	begin
		for c in 1..repeticiones loop
			put("Soy t"); put(caracter); new_line;
			delay duration(temp)/100;
		end loop;
	end tarea;
	
	--| Instanciacion de las tareas parametrizadas:
	t1 : tarea('1', 10, 1);
	t2 : tarea('2', 15, 1);
	t3 : tarea('3',  4, 1);	

begin

	for c in 1..7 loop
		put_line("Soy P");
		delay 0.01;
	end loop;
		
end ada1x03;
