--| 09/10/2012
--| 
--| ENUNCIADO:
--| Ponga a punto un nuevo programa a partir del ejercicio anterior,
--| pero ahora las tres tareas van a estar estructuradas en un vector "T"
--| de tareas de un tipo tarea.
--| Las tareas T(i) tendrn, adems de capacidad para aceptar la cita
--| "identificacin", capacidad para aceptar una nueva cita "parar", de
--| forma que aceptarn la cita "identificacin" e iterarn la escritura
--| de su frase "Soy Ti" hasta que hayan aceptado la cita parar.
--| El procedimiento se encargar de identificar a cada una de las tareas
--| (para que empiecen) y establecer el mecanismo de parada de las tareas
--| (la definicin de este mecanismo se deja para la decidas t).

--| CONCLUSION:
--|	Ahora podemos alterar el funcionamiento de la tarea mediante las citas,
--|	de modo que estas modifiquen el valor de las variables de la tarea y
--|	que asi el comportamiento de esta cambie.

--| EJECUCION:
--| Inicio T1
--|    Soy 1
--|    Soy 1
--|    Soy 1
--|    Soy 1
--| Fin T1
--| Inicio T2
--|    Soy 2
--|    Soy 2
--|    Soy 2
--| Fin T2
--| Inicio T3
--|    Soy 3
--|    Soy 3
--|    Soy 3
--|    Soy 3
--| Fin T3


with Ada.Text_IO;


procedure ada1x05 is

	use Ada.Text_IO;

	
	-- Se especifica un tipo tarea con una cita:
	task type tarea is
		entry identificacion(char:Character);
		entry parar;
	end tarea;
	
	
	--| Se implementa la tarea:
	task body tarea is
		estadoTarea, estadoImprimir : boolean;
		letra:Character;
	begin
		estadoTarea    := true;
		estadoImprimir := false;


		while estadoTarea = true loop	
			select
				accept identificacion(char:Character) do
					put("Inicio T"); put(char); new_line;
					estadoImprimir :=true;
					letra := char;
				end identificacion;
			or
				accept parar do
					estadoTarea    := false;
					estadoImprimir := false;
					put("Fin T"); put(letra); new_line;
				end parar;
			else
				if estadoImprimir then
					put("   Soy "); put(letra); new_line;
					delay 0.3;
				end if;
			end select;
		end loop;				
	end tarea;
	
	-- Se crea el vector de tareas y se instancia:
	type vectorTarea is array(1..3) of tarea;
	vt:vectorTarea;

	
begin

	-- Se llama a la cita de las tareas de forma parametrizada:
	vt(1).identificacion('1');
	delay 1.0;
	vt(1).parar;
	
	vt(2).identificacion('2');
	delay 1.0;
	vt(2).parar;	
	
	vt(3).identificacion('3');
	delay 1.0;
	vt(3).parar;		
		
end ada1x05;
