--| 10/10/2012
--| IMPLEMENTACIÓN



-- Funciones del paquete:
package body matrices_con_tareas is



	--| Implementacion del tipo Tarea:
	task body Tarea is
	begin
		accept calcular( mA:Matriz ; mB:Matriz ; i:Positive ; j:Positive ; mR:out Matriz ) do

			-- Se pone a cero la celda de destino:
			mR(i,j) := 0;	

			for k in mb'range(1) loop
				mR(i,j) := mR(i,j) + mA(i,k) * mB(k,j);
			end loop;

		end calcular;
	end Tarea;



	--| Funcion que multiplica dos matrices:
	function "*"(mA:in matriz ; mB:in matriz) return matriz is
		tmp:matriz(1..filas , 1..columnas);
		pT:pTarea;
	begin
		-- Se calcula la matriz resultante
		for i in mA'range(1) loop
			for j in mB'range(2) loop
				
				-- Se crea una nueva tarea dinamica y se llama a su cita parametrizada:
				pT := new Tarea;
				pt.calcular( mA , mB , i , j , tmp );
				
			end loop;
		end loop;

		return tmp;	
	end "*";
	
	
	
	-- Funcion que devuelve un numero aleatorio:
	function randomInteger(max:in Integer) return Integer is
		package pos_io is new text_io.integer_io(positive);
	begin
		return random.positive_random(maximo => max);
	end randomInteger;	
	
	
	
	-- Procedimiento que crea los numeros aleatorios para las matrices:
	procedure createFileOfRandomNumbers( filMA:Positive ; colMA:Positive ; colMB:Positive ; numMax:Positive  ) is
		num:Positive := filMA*colMA + colMA*colMB;
		miFichero : f.File_Type;
	begin
		put("Generando los numeros aleatorios en el fichero 'numeros.dat'..."); new_line;
		
		-- Create (File=>miFichero , Mode=>Out_File , Name=>"numeros.dat");
		Open( File => miFichero , Mode=>Out_File , Name=>"numeros.dat" );
		
		for i in 1..num loop	
			Write( File=>miFichero , Item=>randomInteger(numMax) );
		end loop;	
	
		Close(miFichero);
	
	end createFileOfRandomNumbers;
	
	
	
	-- Procedimiento que lee numeros de un fichero y los devuelve en dos matrices:
	procedure readFileOfRandomNumbers( mA:Out Matriz ; mB:Out Matriz ) is
		miFichero : f.File_Type;
		num:Integer;
		contador:Integer := 0;
	begin
		Open( File => miFichero , Mode=>In_File , Name=>"numeros.dat" );
		
		-- Se cargan los numeros de la matriz A
		for i in mA'range(1) loop
			for j in mA'range(2) loop
				Read( File=>miFichero , Item=>num );
				mA(i,j) := num;
				contador := contador +1;
			end loop;
		end loop;
		
		
		-- Se cargan los numeros de la matriz B
		for i in mB'range(1) loop
			for j in mB'range(2) loop
				Read( File=>miFichero , Item=>num );
				mB(i,j) := num;
				contador := contador +1;
			end loop;
		end loop;
				
		Close(miFichero);
		put("Cargados a memoria "); put(contador, width=>1); put_line(" numeros.");
		
	end readFileOfRandomNumbers;
	
	
	
	-- Procedimiento que imprime una matriz por pantalla:
	procedure put( m:in Matriz ) is
	begin
		new_line;	
		for i in m'range(1) loop
			for j in m'range(2) loop
				put( m(i,j) );
			end loop;
			new_line;
		end loop;
		new_line;		
	end put;
	

end matrices_con_tareas;
