--| 23/10/2012
--| 
--| ENUNCIADO:
--| Se trata de crear una serie de procesos que se van a ejecutar de forma concurrente / paralela
--| produciendo y consumiendo datos o encargndose de su gestin. Para ello vamos a tener:
--| 
--| 	Procesos productores:
--| 		Se dormirn por un tiempo aleatorio que se calcula cada vez y tras ese tiempo producirn
--| 		un dato entero, que constar del nmero de productor (codificado en los miles) y del dato
--| 		que toca (que llega slo hasta 999 y luego empieza en 0 de nuevo). Por ejemplo si es el
--| 		tercer dato que produce el productor 5, el entero que producir ser el 5003. Informarn
--| 		de su produccin por consola, sacando un mensaje que indique claramente el dato producido.
--| 		Una vez producido, lo guardarn en el almacn.
--|
--| 	Procesos consumidores:
--| 		Cogern un dato del almacn, y se dormirn durante una cantidad de tiempo aleatoria simulando
--| 		que usan tiempo en consumirlo. Al terminar, sacarn un mensaje por pantalla indicando qu
--| 		consumidor son y qu dato han consumido del almacn.
--|
--| 	Proceso almacn:
--| 		Gestionar un buffer en el que ir guardando lo que produzcan los productores hasta que lo
--| 		consuman los consumidores. Cada vez que guarde algo de un productor, informar por consola
--| 		del dato almacenado. Cada vez que un consumidor quiera un dato, le dar el ms antiguo
--| 		almacenado e informar por consola de que ese dato sale del almacn.
--|
--| 	Proceso principal:
--| 		Preguntar al usuario cuntos productores desea y cuntos consumidores y pondr en marcha
--| 		todo lo necesario.

--| CONCLUSION:
--| Con este programa se pueden observar varis cosas.
--| 	Primero que al ser la tarea Almacn la que gestiona la memoria, y no directamente los procesos
--| 	Productores y Consumidores, se gestiona correctamente.
--|
--| 	Segundo que por la forma de funcionar el proceso Consumidor, intenta leer algo si puede y si
--| 	no espera, acapara el terminal imprimiendo muchas veces "El consumidor no pudo consumir...".
--| 	Por ello comente esa lnea para no ensuciar el resultado.
--|
--| 	Tercero que la memoria RAM que se usa es minima. Despus de que 9 procesos hayan creado y
--| 	guardado cada uno mas de 3000 nmeros, es decir, cada uno de ellos llego al Producto 999 y
--| 	volvi a empezar 3 veces, la memoria usada es de tan solo 2MiB (fue aumentando poco a poco de
--| 	los 700KiB iniciales a los 2MiB mencionados). En esa prueba solo habia un proceso consumidor e
--| 	iba por la primera ronda con el Producto 300.



with
 Ada.Text_IO,
 Ada.Integer_Text_IO,
 pProductores;
 
 
procedure ada1x08 is

	use Ada.Text_IO;
	use Ada.Integer_Text_IO;
	use pProductores;

	productores, consumidores : Integer := 0;
	
begin

	-- Se solicita el numero de procesos Productores:
	put("Indique el numero de Productores:  ");
	get(productores); new_line;
	
	
	-- Se solicita el numero de procesos Consumidores:
	put("Indique el numero de Consumidores: ");
	get(consumidores); new_line; new_line;
	
	
	-- Se inicia el programa:
	iniciar(productores , consumidores);
	
end ada1x08;
