--| 15/03/2012
--| ESPECIFICACIN DE LA COLA DINAMICA

--| PRECONDICIN:
--| Se ha de recibir de la instanciacion de la librera, un parmetro de tipo natural y el tipo de datos a almacenar en cada Nodo de la Cola.
--| Se ha de controlar que la pila no este vaca/llena con las funciones esVacia/esLlena antes de usar insertar/leer/extraer.




generic

	-- Parmetros recibidos de la instanciacion de la librera: (private - limited private)
	type datos is private;


package cola_dinamica is


	-- Se definen las cabeceras (como private - limited private) de los tipos de datos que emplearan las funciones, se terminan de definir en la zona private:
	type ptCola is limited private;


	-- Se definen las cabeceras de las funciones contenidas en el fichero de implementacin:
	procedure inicializar( c:in out ptCola              );
	function      esVacia( c:in     ptCola              ) return boolean;
	procedure    insertar( c:in out ptCola; d:in datos  );
	function         leer( c:in     ptCola              ) return datos;
	procedure     extraer( c:in out ptCola; d:out datos );
	procedure      borrar( c:in out ptCola              );


	-- Desde la zona privada, se detalla como son las variables declaradas previamente como privadas:
	private

		type nodo;
		type ptNodo is access nodo;

		type cola;
		type ptCola is access cola;


		type nodo is record
			elemento :datos;
			siguiente:ptNodo;
		end record;


		type cola is record
			numNodos:integer;
			primero:ptNodo;
			ultimo:ptNodo;
		end record;

end cola_dinamica;