--| 23/10/2012
--| IMPLEMENTACIÓN



-- Funciones del paquete:
package body pProductores is

	-- Se crea un Almacen y punteros a las tareas:
	cola:ptCola;
	pA:pAlmacen;
	pP:pProductor;
	pC:pConsumidor;	



	--| Implementacion de la tarea Productor:
	task body Productor is
		numProductor : Integer := id * 1000;
		numProducto  : Integer :=0;
		g            : Generator; --Para la semilla.
	begin
		reset(g); -- Se crea la semilla.
			
		loop
			-- Se borra el contador si se sobrepasa el 999 o se suma una unidad:
			if numProducto >= 999 then
				numProducto := 0;
			else
				numProducto := numProducto + 1;	
			end if;

			-- Fabricando (Pause):
			delay( Duration(Random(g)) );
			
			-- Se hace la insercion en el Almacen:
			put("    Producido: "); put(numProductor + numProducto , width=>1); new_line;
			pA.insert( numProductor + numProducto );

		end loop;
	end Productor;



	--| Implementacion de la tarea Consumidor:	
	task body Consumidor is
		numConsumidor : Integer := id;
		temp          : Integer;
		g             : Generator; --Para la semilla.
	begin
		reset(g); -- Se crea la semilla.
		
		loop
			-- Se extrae un Producto si lo hay:
			if esVacia(cola) then
				--put("Consumidor "); put(numConsumidor , width=>1); put(" no pudo consumir nada."); new_line;
				null;
			else
				pA.extract(temp);
				
				-- Consumiendo (Pause):
				delay( Duration(Random(g)) );
				
				put("Consumidor "); put(numConsumidor , width=>1); put(" : "); put(temp , width=>1); new_line;			
			end if;	
			
		end loop;
	end Consumidor;
	
	
	
	--| Implementacion de la tarea Almacen con sus citas:
	task body Almacen is
	begin
		loop
			select
			
				accept insert( dato: in Integer ) do
					insertar( cola, dato );
					put("     Guardado: "); put(dato , width=>1); new_line;
				end insert;
			or
				accept extract( dato:out Integer ) do
					extraer( cola, dato );
					put("     Extraido: "); put(dato , width=>1); new_line;
				end extract;
				
			end select;
		end loop;
	end Almacen;		
	
	
	
	-- Procedimiento que inicializa el almacen y crea las tareas:
	procedure iniciar( productores:in Integer ; consumidores:in Integer ) is
	begin
		
		-- Se inicia ula Cola:
		inicializar(cola);
		
		-- Se Instancia un almacen.
		pA := new Almacen;
		
		-- Se instancian X Productores:
		for i in 1..productores loop
			pP := new Productor(i);
		end loop;
		
		-- Se instancian X Consumidores:
		for i in 1..consumidores loop
			pC := new Consumidor(i);
		end loop;
		
	end iniciar;
	
	

end pProductores;
