--| 23/10/2012
--| ESPECIFICACIN



with Text_IO;
with Ada.Integer_Text_IO;
with Ada.Numerics.Discrete_Random;
with cola_dinamica;
   
use Text_IO;
use Ada.Integer_Text_IO;



package pProductores is


	-- Se instancia el paquete de Colas Dinamicas:
	package c is new cola_dinamica(Integer);
	use c;
	
	-- Paquete para la conversion de tipos:
	package d is new Fixed_IO(Duration);
	use d;
	
	-- Paquete para los numeros aleatorios:
	subtype ref is Integer range 1..10; --Rango de numeros a salir.
	package r is new Ada.Numerics.Discrete_Random(ref);
	use r;	

	
	-- Especificacion de las tareas:
	task type Productor( id:Integer );
	
	task type Consumidor( id:Integer );
	
	task type Almacen is
		entry insert( dato: in Integer );
		entry extract( dato:out Integer );
	end Almacen;		
	
	
	-- Puntero a las tareas::
	type pProductor is access Productor;
	type pConsumidor is access Consumidor;
	type pAlmacen is access Almacen;
		
		
	-- Funciones y procedimientos:
	procedure iniciar( productores:in Integer ; consumidores:in Integer );

	
	private
	
end pProductores;
